; ++++ Explorer Type Example ++++
; ++ Programmed by Luis Costa +++
; ++++ xandaz@hotmail.com +++++
; ++++ Lisbon, Portugal 2010 +++++

.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateControls          PROTO	:DWORD
FillControls               PROTO        :DWORD
AddString                PROTO          :DWORD,:DWORD,:WORD
DeleteLast               PROTO          :DWORD,:WORD
CreateImageList 	PROTO          :DWORD
DeleteFileFromSpec      PROTO   :DWORD
AddStringNoBar          PROTO   :DWORD,:DWORD
ProcessTVN_SELCHANGED   PROTO   :DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc
include \masm32\include\shell32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\shell32.lib

.const

MainWindowWidth         equ             600
MainWindowHeight        equ             400

; ++++ Common Controls related +++++

TreeViewID                  equ             100h
ListViewID                    equ             200h
ToolbarID                    equ              300h
StaticID                        equ             400h

; ++++ Other Vars ++++

NoButtons                       equ             7
ToolbarHeight                 equ              42
StaticHeight                    equ             24
Seps                              equ             2

NoTreeViewBitmaps                       equ             2
NoToolbarBitmaps                          equ             6

.data

hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow     dd              ?
MainWindowClass db              'MainWindowClass',0
MainWindowName  db              'Explorer Type Example',0

; ++++ TreeView related +++++

TreeViewClass   db      'SysTreeView32',0
hTreeView        dd                     ?
tvis            TV_INSERTSTRUCT         <>
tvi             TV_ITEM                         <>

; ++++ ListView related +++++

ListViewClass     db      'SysListView32',0
hListView           dd                  ?
lvi             LV_ITEM                         <>
hListS                  dd                ?
hListL                  dd                 ?
LVSmallString      db           'Small Icon View',0
LVLargeString      db           'Large Icon View',0
lvc             LV_COLUMN                   <>
NameString      db              'FileName',0
TypeNameString  db           'Type',0
AttributesString        db      'Attributes',0

; +++++ ReBar related   +++++

ReBarClass       db     'ReBarWindow32',0
hReBar             dd                   ?

; ++++ Toolbar related +++++

ToolbarClass    db      'ToolbarWindow32',0
hToolbar          dd                    ?

TBButtons       TBBUTTON        <0,301h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <1,302h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <2,303h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <3,304h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <4,305h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                     TBBUTTON        <5,306h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
        
ToolbarBitmapsSpecs      LABEL   DWORD
                        db              '.\dv.bmp',0
                        db              '.\dvmask.bmp',0
                        db              '.\iv.bmp',0
                        db              '.\ivmask.bmp',0
                        db              '.\lv.bmp',0
                        db              '.\lvmask.bmp',0
                        db              '.\si.bmp',0
                        db              '.\simask.bmp',0
                        db              '.\tv.bmp',0
                        db              '.\tvmask.bmp',0
                        db              '.\close.bmp',0
                        db              '.\closemask.bmp',0
                              
; ++++ Static related +++++

StaticClass     db              'STATIC',0
hStatic           dd                    ?
                     
; ++++ Others +++++

rect                    RECT            <>
StartPath                     db        'c:\*',0,256 dup(0)
w32fd                   WIN32_FIND_DATA         <>
AttrBuffer              db      5       dup(0)
hFind                 dd                ?
hList                   dd             ?
hList2                  dd              ?
IconIdentifiers         dd              4,2eh
szShell32               db              'c:\windows\system32\shell32.dll',0
hResource               dd              ?
SelectedDirectory       db      256 dup(0)
DirectoryBuffer         db              128 dup(0)
shfi                    SHFILEINFO	     <>
BlankString             db      128 Dup(' ')
.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  GetCommandLine
                mov     CommandLine,eax
                invoke  InitCommonControls
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_HREDRAW+CS_VREDRAW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MainWindowClass
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.hbrBackground,COLOR_WINDOW
        push    hInst
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,MainWindowHeight/2
        push    eax
        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,MainWindowWidth/2
        pop     ebx
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax
        invoke  ShowWindow,eax,SW_SHOWNORMAL
        invoke  UpdateWindow,hMainWindow

         
        .while  TRUE
        
                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
        
        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL
        .elseif uMsg==WM_CREATE
                mov     edi,lParam
                .if     [edi.CREATESTRUCT].hWndParent==NULL
                        invoke  CreateImageList,hWnd
                        invoke  CreateControls,hWnd
                        invoke  FillControls,hWnd
                .endif                        
        .elseif uMsg==WM_SIZE
        .elseif uMsg==WM_NOTIFY
                mov     edi,lParam
                .if     [edi.NM_TREEVIEW].hdr.code==TVN_SELCHANGED
                invoke  ProcessTVN_SELCHANGED,lParam
                call    FindFilesProc
                .endif                                                
        .elseif uMsg==WM_COMMAND
                mov     eax,wParam
                .if           ax==301h
                        invoke  SendMessage,hListView,LVM_SETVIEW,LV_VIEW_DETAILS,NULL
                        call    ClearStatic
                        invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr LVSmallString
                .elseif     ax==302h
                        invoke  SendMessage,hListView,LVM_SETVIEW,LV_VIEW_ICON,NULL
                        call    ClearStatic
                        invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr LVLargeString
                .elseif     ax==303h
                        invoke  SendMessage,hListView,LVM_SETVIEW,LV_VIEW_LIST,NULL
                .elseif     ax==304h
                        invoke  SendMessage,hListView,LVM_SETVIEW,LV_VIEW_SMALLICON,NULL
                .elseif     ax==305h
                        invoke  SendMessage,hListView,LVM_SETVIEW,LV_VIEW_TILE,NULL
                .elseif     ax==306h
                        invoke  PostQuitMessage,NULL                                                
                .endif                               
        .else

                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                ret

        .endif

        xor     eax,eax
        ret

WndProc endp

CreateControls  PROC    hWnd:DWORD

        invoke  GetClientRect,hWnd,addr rect
        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT,\
                                0,0,rect.right,NULL,hWnd,ToolbarID,hInstance,NULL
        mov     hToolbar,eax
        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
        invoke  SendMessage,hToolbar,TB_SETIMAGELIST,NULL,hList2        
        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
        invoke  SendMessage,hToolbar,TB_SETBUTTONSIZE,NULL,200020h
        invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL
        add     rect.top,ToolbarHeight
        sub     rect.bottom,ToolbarHeight+StaticHeight+Seps
        push    rect.right
        shr     rect.right,2
        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+TVS_LINESATROOT+TVS_HASLINES+TVS_HASBUTTONS,\
                        rect.left,rect.top,rect.right,rect.bottom,hWnd,TreeViewID,hInstance,NULL
        mov     hTreeView,eax
        invoke  SendMessage,hTreeView,TVM_SETIMAGELIST,TVSIL_NORMAL,hList
        mov     eax,rect.right
        pop     rect.right
        add     eax,2
        mov     rect.left,eax
        sub     rect.right,eax
        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD+LVS_REPORT,\                                                                     
                        rect.left,rect.top,rect.right,rect.bottom,hWnd,ListViewClass,hInstance,NULL
        mov     hListView,eax
        mov     eax,rect.right
        shr     eax,2
        mov     lvc.lx,eax
        mov     lvc.imask,LVCF_TEXT+LVCF_WIDTH
        mov     lvc.pszText,offset NameString
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,0,addr lvc
        mov     lvc.pszText,offset TypeNameString
        mov     eax,lvc.lx
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,1,addr lvc
        mov     lvc.pszText,offset AttributesString
        or      lvc.imask,LVCF_FMT
        mov     lvc.fmt,LVCFMT_CENTER
        invoke	SendMessage,hListView,LVM_INSERTCOLUMN,2,addr lvc
        mov     eax,rect.top
        add     eax,rect.bottom
        add     eax,2
        push    eax
        invoke  GetClientRect,hWnd,addr rect
        pop     eax
        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_SIMPLE,\
                        0,eax,rect.right,24,hWnd,StaticID,hInstance,NULL
        mov     hStatic,eax   
        invoke  SendMessage,hTreeView,WM_GETFONT,NULL,NULL
        invoke  SendMessage,hStatic,WM_SETFONT,eax,FALSE                             
        ret

CreateControls  endp

FillControls    PROC    hWnd:DWORD

        mov     tvis.hParent,NULL
        mov     tvis.hInsertAfter,TVI_LAST
        mov     tvis.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE
        mov     tvis.item.iImage,0
        mov     tvis.item.iSelectedImage,1
@@1:        
        invoke  FindFirstFile,addr StartPath,addr w32fd                
        cmp     eax,INVALID_HANDLE_VALUE
        je      error_nomore_files
        mov     hFind,eax
@@2:

        cmp     w32fd.cFileName,'.'
        je       @@3
        test     w32fd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
        jnz       @@4
@@3:        
        invoke        FindNextFile,hFind,addr w32fd
        cmp   eax,NULL
        je      error_nomore_files
        jmp    @@2
@@4:        
        push    offset w32fd.cFileName
        pop     tvis.item.pszText
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        push    tvis.hParent
        push    hFind
        mov     tvis.hParent,eax
        invoke  AddString,addr StartPath,addr w32fd.cFileName,'*\'
        jmp     @@1
error_nomore_files:
        cmp     tvis.hParent,NULL
        je        end_fc
        invoke  CloseHandle,hFind
        pop     hFind
        pop     tvis.hParent
        invoke  DeleteLast,addr StartPath,'*\'
        jmp     @@3
end_fc:        
        invoke  CloseHandle,hFind
        ret

FillControls    endp

AddString       PROC    DestinationString:DWORD,StringAdd:DWORD,Suffix:WORD

        push    eax
        push    esi
        push    edi
        pushf
        mov     esi,DestinationString
        cld
@@1:    
        lodsb
        cmp     al,0
        jne     @@1
        sub       esi,2
        mov     edi,esi
        mov     esi,StringAdd
@@2:
        lodsb
        cmp     al,0
        je      pre_end
        stosb
        jmp     @@2
pre_end:        
        mov     ax,Suffix
        stosw
        mov     al,0
        stosb
        popf
        pop     edi
        pop     esi
        pop     eax
        ret

AddString       endp                                  

DeleteLast      PROC    SourceString:DWORD,Suffix:WORD

        push    eax
        push    esi
        push    edi
        pushf
        mov     esi,SourceString
        cld
@@1:
        lodsb
        cmp     al,0
        jne     @@1
        std
        mov     ecx,2
        dec     esi
@@2:
        lodsb
        cmp     al,'\'
        jne     @@2
        dec     ecx
        jcxz    @@3
        jmp     @@2
@@3:   
        inc     esi
        cld
        mov     edi,esi
        mov     ax,'*\'
        stosw
        mov     al,0
        stosb
        pop     edi
        pop     esi
        pop     eax
        popf
        ret

DeleteLast      endp              

CreateImageList PROC    hWnd:DWORD

        local   hIcon:DWORD
        local   hBitmap:DWORD
        local   hBitmapMask:DWORD
        
        invoke  LoadLibraryEx,addr szShell32,NULL,LOAD_LIBRARY_AS_DATAFILE
        mov     hResource,eax
        invoke  ImageList_Create,16,16,ILC_COLOR16+ILC_MASK,2,2
        mov     hList,eax
        mov     ecx,NoTreeViewBitmaps
        lea       esi,IconIdentifiers
        cld
cil_loop:          
        push    ecx             
        lodsd
        invoke  LoadImage,hResource,eax,IMAGE_ICON,16,16,LR_SHARED
        mov     hIcon,eax
        invoke  ImageList_AddIcon,hList,eax
        invoke  DestroyIcon,hIcon
        pop     ecx
        dec     ecx
        jcxz    next_loop
        jmp     cil_loop
next_loop:
        invoke  ImageList_Create,32,32,ILC_COLOR32+ILC_MASK,12,12
        mov     hList2,eax
        mov     ecx,NoToolbarBitmaps
        lea       esi,ToolbarBitmapsSpecs
cil_loop2:
        push    ecx
        invoke  LoadImage,hInstance,esi,IMAGE_BITMAP,32,32,LR_LOADFROMFILE+LR_SHARED
        mov     hBitmap,eax        
realign_loop:
        lodsb
        cmp     al,0
        jne     realign_loop
        invoke  LoadImage,hInstance,esi,IMAGE_BITMAP,32,32,LR_LOADFROMFILE+LR_SHARED
        mov     hBitmapMask,eax
        invoke  ImageList_Add,hList2,hBitmap,hBitmapMask
        invoke  DeleteObject,hBitmap
        invoke  DeleteObject,hBitmapMask
realign_loop2:
        lodsb
        cmp     al,0
        jne     realign_loop2
        pop     ecx
        dec     ecx
        jcxz   end_cil
        jmp     cil_loop2
end_cil:
        invoke  FreeLibrary,hResource
        ret
                
CreateImageList endp

FindFilesProc       PROC

                local   item:DWORD
                
                invoke  SHGetFileInfo,addr SelectedDirectory,NULL,addr shfi,sizeof shfi,SHGFI_SMALLICON+SHGFI_SYSICONINDEX
                mov     hListS,eax
                invoke  SHGetFileInfo,addr SelectedDirectory,NULL,addr shfi,sizeof shfi,SHGFI_LARGEICON+SHGFI_SYSICONINDEX
                mov     hListL,eax
                dec     edi
                mov     ax,'*'
                stosw
                invoke  SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,hListS
                invoke  SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_NORMAL,hListL
                mov     lvi.imask,LVIF_TEXT+LVIF_IMAGE
                
                invoke  FindFirstFile,addr SelectedDirectory,addr w32fd
                cmp     eax,NULL
                je      ender
                mov     hFind,eax
compare:                
                cmp     w32fd.cFileName,'.'
                je      nexter
                test     w32fd.dwFileAttributes,FILE_ATTRIBUTE_NORMAL
                je     do
nexter:                                
                invoke  FindNextFile,hFind,addr w32fd
                cmp     eax,NULL
                je      ender
                jmp     compare
do:                
                invoke  AddStringNoBar,addr SelectedDirectory,addr w32fd.cFileName
                invoke  SHGetFileInfo,addr SelectedDirectory,NULL,addr shfi,sizeof shfi,SHGFI_SMALLICON +SHGFI_SYSICONINDEX
                push    hList
                pop     lvi.lParam
                push    shfi.iIcon
                pop     lvi.iImage
                mov     lvi.iSubItem,0
                push    offset w32fd.cFileName
                pop     lvi.pszText
                invoke  SendMessage,hListView,LVM_INSERTITEM,NULL,addr lvi
                push    eax
                pop     item
                invoke  SHGetFileInfo,addr SelectedDirectory,NULL,addr shfi,sizeof shfi,SHGFI_TYPENAME+SHGFI_ATTRIBUTES
                mov     lvi.iSubItem,1
                push    offset shfi.szTypeName
                pop     lvi.pszText
                invoke  SendMessage,hListView,LVM_SETITEM,item,addr lvi
                lea     edi,AttrBuffer
                cld
                test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_ARCHIVE
                jz     @@1
                mov     al,'a'
                stosb
                jmp     @@2
@@1:    
                mov     al,'-'
                stosb
@@2:                         
                test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
                jz      @@3
                mov     al,'d'
                stosb
                jmp     @@4
@@3:
                mov     al,'-'
                stosb
@@4:
                test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_SYSTEM
                jz      @@5
                mov     al,'s'
                stosb
                jmp     @@6
@@5:
                mov     al,'-'
                stosb
@@6:
                test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_HIDDEN
                jz     @@7
                mov     al,'h'
                stosb
                jmp     @@8
@@7:
                mov     al,'-'
                stosb
@@8:
                xor     al,al
                stosb
                mov     lvi.pszText,offset AttrBuffer
                mov     lvi.iSubItem,2
                invoke  SendMessage,hListView,LVM_SETITEM,item,addr lvi
                invoke  DeleteFileFromSpec,addr SelectedDirectory
                jmp     nexter
ender:                
                invoke  CloseHandle,hFind
                invoke  SendMessage,hListView,LVM_ARRANGE,LVA_ALIGNLEFT,NULL
                ret
                
FindFilesProc        endp

DeleteFileFromSpec      PROC    FileSpec:DWORD

        push    eax
        push    esi
        push    edi
        pushf
        mov     esi,FileSpec
        cld
loop_0:
        lodsb
        cmp     al,0
        jne     loop_0
        dec     esi
        std
loop_2:
        lodsb        
        cmp     al,'\'
        jne     loop_2
        cld
        add     esi,2
        mov     edi,esi
        mov     al,0
        stosb
        popf
        pop     edi
        pop     esi
        pop     eax
        ret
        
DeleteFileFromSpec      endp

AddStringNoBar  PROC    DestinationString:DWORD,StringAdd:DWORD

        push    eax
        push    esi
        push    edi
        pushf
        mov     esi,DestinationString
        cld
loop_0:
        lodsb
        cmp     al,0
        jne     loop_0
        dec     esi
        std
loop_1:
        lodsb
        cmp     al,'\'
        jne     loop_1
        add     esi,2
        mov     edi,esi
        mov     esi,StringAdd
        cld
loop_2:
        lodsb
        cmp     al,0
        je      ender
        stosb
        jmp     loop_2
ender:
        stosb
        popf
        pop     edi
        pop     esi
        pop     eax
        ret

AddStringNoBar  endp                                                        

ProcessTVN_SELCHANGED   PROC    lParam:DWORD

                local   cnt:DWORD
                
                invoke  SendMessage,hListView,LVM_DELETEALLITEMS,NULL,NULL
                mov     eax,[edi.NM_TREEVIEW].itemNew.hItem
                lea     esi,StartPath
                lea     edi,SelectedDirectory
                mov     cnt,0
                push    offset DirectoryBuffer
                pop     tvi.pszText
                movsw        
                movsb        
tvnsc_loop:                
                push    eax
                invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,eax
                inc     cnt     
                cmp     eax,NULL
                jne      tvnsc_loop
                mov     tvi.imask,TVIF_TEXT+TVIF_HANDLE
                mov     tvi.cchTextMax,256
                mov     ecx,cnt
tvnsc_loop2:                
                pop     tvi.hItem
                push    ecx
                invoke  SendMessage,hTreeView,TVM_GETITEM,NULL,addr tvi
                mov     esi,tvi.pszText
sub_loop_1:
                lodsb
                cmp     al,0
                je      end_sl1
                stosb
                jmp     sub_loop_1
end_sl1:
                mov     al,'\'
                stosb
                pop     ecx
                dec     ecx
                jcxz    end_tvnsc
                jmp     tvnsc_loop2
end_tvnsc:
                mov     al,0
                stosb
                invoke  GetClientRect,hStatic,addr rect
                call    ClearStatic
                invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr SelectedDirectory
                ret

ProcessTVN_SELCHANGED   endp

ClearStatic     PROC

                invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr BlankString
                ret

ClearStatic     endp       

end     start                                       